searchNodes=[{"doc":"Elixir high level library for the Ethereum blockchain. This library is based on the methods of the Json RPC API (https://eth.wiki/json-rpc/api).All functions returns {:error, :econnrefused} if no client is listening in the configured URL.You can directly use Elixir integers for quantities or atoms for tags. The library encode/decode Elixir primitive data to/from the blockchain.Compiled code and contract instances are abstracted. The library can compile code and generate a value of type t:compiled_code/0 and that representation can be used to deploy the contact and get a value of contract/0 that can be used in call/5 and call_transaction/5.Some operations allow options. Options are Keyword.t/0 that accepts optional data accepted by the API (see https://eth.wiki/json-rpc/api for details when no details are given in this documentation).The result of some operations are maps with a direct representation of the returns of the operations in the API (see https://eth.wiki/json-rpc/api for details when no details are given in this documentation).","ref":"Etherex.html","title":"Etherex","type":"module"},{"doc":"Returns a list of addresses owned by client.","ref":"Etherex.html#accounts/0","title":"Etherex.accounts/0","type":"function"},{"doc":"Works like accounts/0 but a exception is raised on error.","ref":"Etherex.html#accounts!/0","title":"Etherex.accounts!/0","type":"function"},{"doc":"Returns the number of most recent block.","ref":"Etherex.html#block_number/0","title":"Etherex.block_number/0","type":"function"},{"doc":"Works like block_number/0 but a exception is raised on error.","ref":"Etherex.html#block_number!/0","title":"Etherex.block_number!/0","type":"function"},{"doc":"Performs a call to a function of a deployed contract. This call does not generate a transaction in the blockchain.Examplesiex&gt; owner = List.last(Etherex.accounts!()) iex&gt; {:ok, [value]} = Etherex.compile_solidity!(&quot;priv/solidity/Counter.sol&quot;) ...&gt; |&gt; Etherex.deploy!(owner, [], gas: 1_000_000) ...&gt; |&gt; Etherex.call(owner, &quot;get&quot;, []) iex&gt; value 0","ref":"Etherex.html#call/6","title":"Etherex.call/6","type":"function"},{"doc":"Works like call/6 but a exception is raised on error.","ref":"Etherex.html#call!/6","title":"Etherex.call!/6","type":"function"},{"doc":"Performs a call to a function of a deployed contract, This call generates a transaction in the blockchain.Examplesiex&gt; owner = List.last(Etherex.accounts!()) iex&gt; {:ok, &quot;0x&quot; &lt;&gt; _} = Etherex.compile_solidity!(&quot;priv/solidity/Counter.sol&quot;) ...&gt; |&gt; Etherex.deploy!(owner, [], gas: 1_000_000) ...&gt; |&gt; Etherex.call_transaction(owner, &quot;get&quot;, [])","ref":"Etherex.html#call_transaction/5","title":"Etherex.call_transaction/5","type":"function"},{"doc":"Works like call_transaction/5 but a exception is raised on error.","ref":"Etherex.html#call_transaction!/5","title":"Etherex.call_transaction!/5","type":"function"},{"doc":"Returns the current client version.","ref":"Etherex.html#client_version/0","title":"Etherex.client_version/0","type":"function"},{"doc":"Works like client_version/0 but a exception is raised on error.","ref":"Etherex.html#client_version!/0","title":"Etherex.client_version!/0","type":"function"},{"doc":"Returns the byte code after compiling Solidity source code. Parameter source_or_filename can be the source code or a filename with the source code.If source code is passed, the function tries to send the code to the client to get the compiled contract.If a filename is passed, a local compiler is used to compile the code. If no local compiler can be used or compilation fails then the source code in file is sent to the client.","ref":"Etherex.html#compile_solidity/1","title":"Etherex.compile_solidity/1","type":"function"},{"doc":"Works like compile_solidity/1 but a exception is raised on error.","ref":"Etherex.html#compile_solidity!/1","title":"Etherex.compile_solidity!/1","type":"function"},{"doc":"Deploys a contract to the blockchain.Examplesiex&gt; owner = List.last(Etherex.accounts!()) iex&gt; {:ok, _contract} = Etherex.compile_solidity!(&quot;priv/solidity/Counter.sol&quot;) ...&gt; |&gt; Etherex.deploy(owner, [], gas: 1_000_000)","ref":"Etherex.html#deploy/4","title":"Etherex.deploy/4","type":"function"},{"doc":"Works like deploy/4 but a exception is raised on error.","ref":"Etherex.html#deploy!/4","title":"Etherex.deploy!/4","type":"function"},{"doc":"Generates and returns an estimate of how much gas is necessary to allow the transaction to complete. The transaction will not be added to the blockchain. Note that the estimate may be significantly more than the amount of gas actually used by the transaction, for a variety of reasons including EVM mechanics and node performance.Examplesiex&gt; owner = List.last(Etherex.accounts!()) iex&gt; {:ok, estimated_gas} = Etherex.compile_solidity!(&quot;priv/solidity/Counter.sol&quot;) ...&gt; |&gt; Etherex.deploy!(owner, [], gas: 1_000_000) ...&gt; |&gt; Etherex.estimate_gas(owner, &quot;get&quot;, []) iex&gt; is_integer(estimated_gas) true","ref":"Etherex.html#estimate_gas/5","title":"Etherex.estimate_gas/5","type":"function"},{"doc":"Works like estimate_gas/5 but a exception is raised on error.","ref":"Etherex.html#estimate_gas!/5","title":"Etherex.estimate_gas!/5","type":"function"},{"doc":"Generates and returns an estimate the gas cost of a transaction. It uses estimate_gas/5 and gas_price/0.Examplesiex&gt; owner = List.last(Etherex.accounts!()) iex&gt; {:ok, gas_cost} = Etherex.compile_solidity!(&quot;priv/solidity/Counter.sol&quot;) ...&gt; |&gt; Etherex.deploy!(owner, [], gas: 1_000_000) ...&gt; |&gt; Etherex.estimate_gas_cost(owner, &quot;get&quot;, []) iex&gt; is_integer(gas_cost) true","ref":"Etherex.html#estimate_gas_cost/5","title":"Etherex.estimate_gas_cost/5","type":"function"},{"doc":"Works like estimate_gas_cost/5 but a exception is raised on error.","ref":"Etherex.html#estimate_gas_cost!/5","title":"Etherex.estimate_gas_cost!/5","type":"function"},{"doc":"Returns the gas cost of a transaction. If the transaction hasn't been processed yet (is pending), {:ok, nil} is returned.","ref":"Etherex.html#gas_cost/1","title":"Etherex.gas_cost/1","type":"function"},{"doc":"Works like gas_cost/1 but a exception is raised on error.","ref":"Etherex.html#gas_cost!/1","title":"Etherex.gas_cost!/1","type":"function"},{"doc":"Returns the current price per gas in wei.","ref":"Etherex.html#gas_price/0","title":"Etherex.gas_price/0","type":"function"},{"doc":"Works like gas_price/0 but a exception is raised on error.","ref":"Etherex.html#gas_price!/0","title":"Etherex.gas_price!/0","type":"function"},{"doc":"Returns the balance of the account of given address.","ref":"Etherex.html#get_balance/2","title":"Etherex.get_balance/2","type":"function"},{"doc":"Works like get_balance/2 but a exception is raised on error.","ref":"Etherex.html#get_balance!/2","title":"Etherex.get_balance!/2","type":"function"},{"doc":"Returns information about a block by block number or by block hash.","ref":"Etherex.html#get_block/1","title":"Etherex.get_block/1","type":"function"},{"doc":"Works like get_block/1 but a exception is raised on error.","ref":"Etherex.html#get_block!/1","title":"Etherex.get_block!/1","type":"function"},{"doc":"Returns the deployed bytecode of a contract.","ref":"Etherex.html#get_bytecode/1","title":"Etherex.get_bytecode/1","type":"function"},{"doc":"Returns the address of a contract. If the creation transaction has not been mined yet, nil is returned.","ref":"Etherex.html#get_contract_address/1","title":"Etherex.get_contract_address/1","type":"function"},{"doc":"Works like get_contract_creation_address/1 but a exception is raised on error.","ref":"Etherex.html#get_contract_address!/1","title":"Etherex.get_contract_address!/1","type":"function"},{"doc":"Returns the hash of the creation transaction of a contract.","ref":"Etherex.html#get_contract_creation_hash/1","title":"Etherex.get_contract_creation_hash/1","type":"function"},{"doc":"Returns the contract creator address.","ref":"Etherex.html#get_creator/1","title":"Etherex.get_creator/1","type":"function"},{"doc":"Given a contract and a transaction of the contract, retrieves the list of events logged in it. Returns [] if no events. Returns nil if transaction is pending.","ref":"Etherex.html#get_events/2","title":"Etherex.get_events/2","type":"function"},{"doc":"Works like get_events/2 but a exception is raised on error.","ref":"Etherex.html#get_events!/2","title":"Etherex.get_events!/2","type":"function"},{"doc":"Returns the information about a transaction requested by transaction hash.","ref":"Etherex.html#get_transaction/1","title":"Etherex.get_transaction/1","type":"function"},{"doc":"Works like get_transaction/1 but a exception is raised on error.","ref":"Etherex.html#get_transaction!/1","title":"Etherex.get_transaction!/1","type":"function"},{"doc":"Returns the receipt of a transaction by transaction hash. The receipt is not available for pending transactions and {:ok, nil} is returned.","ref":"Etherex.html#get_transaction_receipt/1","title":"Etherex.get_transaction_receipt/1","type":"function"},{"doc":"Works like get_transaction_receipt/1 but a exception is raised on error.","ref":"Etherex.html#get_transaction_receipt!/1","title":"Etherex.get_transaction_receipt!/1","type":"function"},{"doc":"Returns true if client is actively listening for network connections, false otherwise.","ref":"Etherex.html#net_listening/0","title":"Etherex.net_listening/0","type":"function"},{"doc":"Works like net_listening/0 but a exception is raised on error.","ref":"Etherex.html#net_listening!/0","title":"Etherex.net_listening!/0","type":"function"},{"doc":"Returns the current network id.","ref":"Etherex.html#net_version/0","title":"Etherex.net_version/0","type":"function"},{"doc":"Works like net_version/0 but a exception is raised on error.","ref":"Etherex.html#net_version!/0","title":"Etherex.net_version!/0","type":"function"},{"doc":"Returns the current ethereum protocol version.","ref":"Etherex.html#protocol_version/0","title":"Etherex.protocol_version/0","type":"function"},{"doc":"Works like protocol_version/0 but a exception is raised on error.","ref":"Etherex.html#protocol_version!/0","title":"Etherex.protocol_version!/0","type":"function"},{"doc":"Returns syncing status.","ref":"Etherex.html#syncing/0","title":"Etherex.syncing/0","type":"function"},{"doc":"Works like syncing/0 but a exception is raised on error.","ref":"Etherex.html#syncing!/0","title":"Etherex.syncing!/0","type":"function"},{"doc":"Transfer funds.","ref":"Etherex.html#transfer/4","title":"Etherex.transfer/4","type":"function"},{"doc":"Decimal representation of a value given an Ether unit.Examplesiex&gt; Etherex.wei_to_decimal(0) Decimal.new(&quot;0.0&quot;) iex&gt; Etherex.wei_to_decimal(0, :WEI) Decimal.new(&quot;0.0&quot;) iex&gt; Etherex.wei_to_decimal(0, :ETH) Decimal.new(&quot;0.0&quot;) iex&gt; Etherex.wei_to_decimal(20000000000) Decimal.new(&quot;2E+10&quot;) iex&gt; Etherex.wei_to_decimal(20000000000, :WEI) Decimal.new(&quot;2E+10&quot;) iex&gt; Etherex.wei_to_decimal(20000000000, :GWEI) Decimal.new(&quot;20.0&quot;) iex&gt; Etherex.wei_to_decimal(20000000000, :PWEI) Decimal.new(&quot;0.00002&quot;) iex&gt; Etherex.wei_to_decimal(20000000000, :ETH) Decimal.new(&quot;2E-8&quot;)","ref":"Etherex.html#wei_to_decimal/2","title":"Etherex.wei_to_decimal/2","type":"function"},{"doc":"String representation of a value given an Ether unit.Examplesiex&gt; Etherex.wei_to_string(0) &quot;0 WEI&quot; iex&gt; Etherex.wei_to_string(0, :WEI) &quot;0 WEI&quot; iex&gt; Etherex.wei_to_string(0, :GWEI) &quot;0.000000000 GWEI&quot; iex&gt; Etherex.wei_to_string(0, :PWEI) &quot;0.000000000000000 PWEI&quot; iex&gt; Etherex.wei_to_string(0, :ETH) &quot;0.000000000000000000 ETH&quot; iex&gt; Etherex.wei_to_string(20000000000) &quot;20,000,000,000 WEI&quot; iex&gt; Etherex.wei_to_string(20000000000, :WEI) &quot;20,000,000,000 WEI&quot; iex&gt; Etherex.wei_to_string(20000000000, :GWEI) &quot;20.000000000 GWEI&quot; iex&gt; Etherex.wei_to_string(20000000000, :PWEI) &quot;0.000020000000000 PWEI&quot; iex&gt; Etherex.wei_to_string(20000000000, :ETH) &quot;0.000000020000000000 ETH&quot;","ref":"Etherex.html#wei_to_string/2","title":"Etherex.wei_to_string/2","type":"function"},{"doc":"","ref":"Etherex.html#t:address/0","title":"Etherex.address/0","type":"type"},{"doc":"","ref":"Etherex.html#t:block_parameter/0","title":"Etherex.block_parameter/0","type":"type"},{"doc":"","ref":"Etherex.html#t:bytecode/0","title":"Etherex.bytecode/0","type":"opaque"},{"doc":"","ref":"Etherex.html#t:contract/0","title":"Etherex.contract/0","type":"opaque"},{"doc":"","ref":"Etherex.html#t:error/0","title":"Etherex.error/0","type":"type"},{"doc":"","ref":"Etherex.html#t:event/0","title":"Etherex.event/0","type":"type"},{"doc":"","ref":"Etherex.html#t:hash/0","title":"Etherex.hash/0","type":"type"},{"doc":"","ref":"Etherex.html#t:hex/0","title":"Etherex.hex/0","type":"type"},{"doc":"","ref":"Etherex.html#t:opts/0","title":"Etherex.opts/0","type":"type"},{"doc":"","ref":"Etherex.html#t:quantity/0","title":"Etherex.quantity/0","type":"type"},{"doc":"","ref":"Etherex.html#t:tag/0","title":"Etherex.tag/0","type":"type"},{"doc":"","ref":"Etherex.html#t:unit/0","title":"Etherex.unit/0","type":"type"},{"doc":"Module to start/stop an Ethereum client by using ethnode.Start it with start/0, stop it with stop/0 and get the logs with log/0.","ref":"Etherex.Client.EthnodeGeth.html","title":"Etherex.Client.EthnodeGeth","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etherex.Client.EthnodeGeth.html#child_spec/1","title":"Etherex.Client.EthnodeGeth.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etherex.Client.EthnodeGeth.html#init/1","title":"Etherex.Client.EthnodeGeth.init/1","type":"function"},{"doc":"Returns the list of log lines from the standard output and standard error of the Ethereum client. Resets the log.","ref":"Etherex.Client.EthnodeGeth.html#log/0","title":"Etherex.Client.EthnodeGeth.log/0","type":"function"},{"doc":"Starts an ethereum client using command ethnode.","ref":"Etherex.Client.EthnodeGeth.html#start/0","title":"Etherex.Client.EthnodeGeth.start/0","type":"function"},{"doc":"Stops the ethereum client previously started with command ethnode. Returns the list of log lines from the standard output and standard error since last reset.","ref":"Etherex.Client.EthnodeGeth.html#stop/0","title":"Etherex.Client.EthnodeGeth.stop/0","type":"function"},{"doc":"Module to start/stop an Ethereum client by using ethnode.Start it with start/0, stop it with stop/0 and get the logs with log/0.","ref":"Etherex.Client.EthnodeOpenethereum.html","title":"Etherex.Client.EthnodeOpenethereum","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etherex.Client.EthnodeOpenethereum.html#child_spec/1","title":"Etherex.Client.EthnodeOpenethereum.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etherex.Client.EthnodeOpenethereum.html#init/1","title":"Etherex.Client.EthnodeOpenethereum.init/1","type":"function"},{"doc":"Returns the list of log lines from the standard output and standard error of the Ethereum client. Resets the log.","ref":"Etherex.Client.EthnodeOpenethereum.html#log/0","title":"Etherex.Client.EthnodeOpenethereum.log/0","type":"function"},{"doc":"Starts an ethereum client using command ethnode.","ref":"Etherex.Client.EthnodeOpenethereum.html#start/0","title":"Etherex.Client.EthnodeOpenethereum.start/0","type":"function"},{"doc":"Stops the ethereum client previously started with command ethnode. Returns the list of log lines from the standard output and standard error since last reset.","ref":"Etherex.Client.EthnodeOpenethereum.html#stop/0","title":"Etherex.Client.EthnodeOpenethereum.stop/0","type":"function"},{"doc":"Module to start/stop an Ethereum client by using ganache-cli.Start it with start/0, stop it with stop/0 and get the logs with log/0.","ref":"Etherex.Client.GanacheCLI.html","title":"Etherex.Client.GanacheCLI","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etherex.Client.GanacheCLI.html#child_spec/1","title":"Etherex.Client.GanacheCLI.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etherex.Client.GanacheCLI.html#init/1","title":"Etherex.Client.GanacheCLI.init/1","type":"function"},{"doc":"Returns the list of log lines from the standard output and standard error of the Ethereum client. Resets the log.","ref":"Etherex.Client.GanacheCLI.html#log/0","title":"Etherex.Client.GanacheCLI.log/0","type":"function"},{"doc":"Starts an ethereum client using command ganache-cli.","ref":"Etherex.Client.GanacheCLI.html#start/0","title":"Etherex.Client.GanacheCLI.start/0","type":"function"},{"doc":"Stops the ethereum client previously started with command ganache-cli. Returns the list of log lines from the standard output and standard error since last reset.","ref":"Etherex.Client.GanacheCLI.html#stop/0","title":"Etherex.Client.GanacheCLI.stop/0","type":"function"},{"doc":"Module to start/stop an Ethereum client by using geth.Start it with start/0, stop it with stop/0 and get the logs with log/0.","ref":"Etherex.Client.Geth.html","title":"Etherex.Client.Geth","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etherex.Client.Geth.html#child_spec/1","title":"Etherex.Client.Geth.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etherex.Client.Geth.html#init/1","title":"Etherex.Client.Geth.init/1","type":"function"},{"doc":"Returns the list of log lines from the standard output and standard error of the Ethereum client. Resets the log.","ref":"Etherex.Client.Geth.html#log/0","title":"Etherex.Client.Geth.log/0","type":"function"},{"doc":"Starts an ethereum client using command geth.","ref":"Etherex.Client.Geth.html#start/0","title":"Etherex.Client.Geth.start/0","type":"function"},{"doc":"Stops the ethereum client previously started with command geth. Returns the list of log lines from the standard output and standard error since last reset.","ref":"Etherex.Client.Geth.html#stop/0","title":"Etherex.Client.Geth.stop/0","type":"function"},{"doc":"Module to start/stop an Ethereum client by using openethereum.Start it with start/0, stop it with stop/0 and get the logs with log/0.","ref":"Etherex.Client.Openethereum.html","title":"Etherex.Client.Openethereum","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etherex.Client.Openethereum.html#child_spec/1","title":"Etherex.Client.Openethereum.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etherex.Client.Openethereum.html#init/1","title":"Etherex.Client.Openethereum.init/1","type":"function"},{"doc":"Returns the list of log lines from the standard output and standard error of the Ethereum client. Resets the log.","ref":"Etherex.Client.Openethereum.html#log/0","title":"Etherex.Client.Openethereum.log/0","type":"function"},{"doc":"Starts an ethereum client using command openethereum.","ref":"Etherex.Client.Openethereum.html#start/0","title":"Etherex.Client.Openethereum.start/0","type":"function"},{"doc":"Stops the ethereum client previously started with command openethereum. Returns the list of log lines from the standard output and standard error since last reset.","ref":"Etherex.Client.Openethereum.html#stop/0","title":"Etherex.Client.Openethereum.stop/0","type":"function"},{"doc":"Types and functions related to bytecode and contracts.","ref":"Etherex.Contract.html","title":"Etherex.Contract","type":"module"},{"doc":"See Etherex.call/5","ref":"Etherex.Contract.html#call/6","title":"Etherex.Contract.call/6","type":"function"},{"doc":"Seel Etherex.call_transaction/4.","ref":"Etherex.Contract.html#call_transaction/5","title":"Etherex.Contract.call_transaction/5","type":"function"},{"doc":"See Etherex.compile_solidity/1.","ref":"Etherex.Contract.html#compile_solidity/1","title":"Etherex.Contract.compile_solidity/1","type":"function"},{"doc":"See Etherex.deploy/3.","ref":"Etherex.Contract.html#deploy/4","title":"Etherex.Contract.deploy/4","type":"function"},{"doc":"See Etherex.estimate_gas/4.","ref":"Etherex.Contract.html#estimate_gas/5","title":"Etherex.Contract.estimate_gas/5","type":"function"},{"doc":"Given a contract, returns its address if the creation transaction has already been mined.","ref":"Etherex.Contract.html#get_address/1","title":"Etherex.Contract.get_address/1","type":"function"},{"doc":"Given a contract, returns its deployed bytecode.","ref":"Etherex.Contract.html#get_bytecode/1","title":"Etherex.Contract.get_bytecode/1","type":"function"},{"doc":"","ref":"Etherex.Contract.html#get_constructor_spec/1","title":"Etherex.Contract.get_constructor_spec/1","type":"function"},{"doc":"","ref":"Etherex.Contract.html#get_contract_address/1","title":"Etherex.Contract.get_contract_address/1","type":"function"},{"doc":"Given a contract, returns the contract creation transaction hash.","ref":"Etherex.Contract.html#get_creation_hash/1","title":"Etherex.Contract.get_creation_hash/1","type":"function"},{"doc":"Given a contract, returns its creator address.","ref":"Etherex.Contract.html#get_creator/1","title":"Etherex.Contract.get_creator/1","type":"function"},{"doc":"","ref":"Etherex.Contract.html#get_event_specs/1","title":"Etherex.Contract.get_event_specs/1","type":"function"},{"doc":"See Etherex.get_events/2.","ref":"Etherex.Contract.html#get_events/2","title":"Etherex.Contract.get_events/2","type":"function"},{"doc":"","ref":"Etherex.Contract.html#get_function_spec/2","title":"Etherex.Contract.get_function_spec/2","type":"function"},{"doc":"Bytecode and specification of a contract.","ref":"Etherex.Contract.html#t:bytecode/0","title":"Etherex.Contract.bytecode/0","type":"type"},{"doc":"Data of the instance of a contract deployed in a blockchain.","ref":"Etherex.Contract.html#t:contract/0","title":"Etherex.Contract.contract/0","type":"opaque"},{"doc":"Some Ethereum clients support jumping through time simulating time events like advance the time and the blocks or set and revert to a snapshot.Ganache-cli, for example, support the following non-standard JSON RPC methods:evm_snapshot : Snapshot the state of the blockchain at the current block. Takes no parameters. Returns the integer id of the snapshot created. A snapshot can only be used (reverted) once.evm_revert : Revert the state of the blockchain to a previous snapshot. Takes a single parameter, which is the snapshot id to revert to. This deletes the given snapshot, as well as any snapshots taken after.evm_increaseTime : Jump forward in time. Takes one parameter, which is the amount of time to increase in seconds. Returns the total time adjustment, in seconds.evm_mine : Force a block to be mined. Takes one optional parameter, which is the timestamp a block should setup as the mining time. Mines a block independent of whether or not mining is started or stopped.","ref":"Etherex.Time.html","title":"Etherex.Time","type":"module"},{"doc":"Forces a block to be mined. Takes one optional parameter, which is the timestamp a block should setup as the mining time. Returns the block mined.","ref":"Etherex.Time.html#mine/1","title":"Etherex.Time.mine/1","type":"function"},{"doc":"Enables automatic mining.","ref":"Etherex.Time.html#miner_start/0","title":"Etherex.Time.miner_start/0","type":"function"},{"doc":"Disables automatic mining.","ref":"Etherex.Time.html#miner_stop/0","title":"Etherex.Time.miner_stop/0","type":"function"},{"doc":"","ref":"Etherex.Time.html#revert/1","title":"Etherex.Time.revert/1","type":"function"},{"doc":"","ref":"Etherex.Time.html#snapshot/0","title":"Etherex.Time.snapshot/0","type":"function"},{"doc":"Basic types in Ethereum.","ref":"Etherex.Type.html","title":"Etherex.Type","type":"module"},{"doc":"20 bytes account addresses in hex representation (starting with &quot;0x&quot;)","ref":"Etherex.Type.html#t:address/0","title":"Etherex.Type.address/0","type":"type"},{"doc":"Block parameters are block numbers or a tag.","ref":"Etherex.Type.html#t:block_parameter/0","title":"Etherex.Type.block_parameter/0","type":"type"},{"doc":"Call error contains the hash of the transaction, the error type (for example revert) and the reason.","ref":"Etherex.Type.html#t:call_error/0","title":"Etherex.Type.call_error/0","type":"type"},{"doc":"Errors: :econnrefused when no client is listening, otherwise, when the client encounters an error a short description of the error","ref":"Etherex.Type.html#t:error/0","title":"Etherex.Type.error/0","type":"type"},{"doc":"Events emitted in a new message call transcation.","ref":"Etherex.Type.html#t:event/0","title":"Etherex.Type.event/0","type":"type"},{"doc":"32 bytes hashes in hex representation (starting with &quot;0x&quot;)","ref":"Etherex.Type.html#t:hash/0","title":"Etherex.Type.hash/0","type":"type"},{"doc":"Numbers, byte arrays, account addresses, hashes, and bytecode arrays encoded as hex, prefix with “0x”, two hex digits per byte.","ref":"Etherex.Type.html#t:hex/0","title":"Etherex.Type.hex/0","type":"type"},{"doc":"Options that can be used in some Etherex function calls.","ref":"Etherex.Type.html#t:opts/0","title":"Etherex.Type.opts/0","type":"type"},{"doc":"Quantities as non negative integers (used in values, block height, counts, etc.)","ref":"Etherex.Type.html#t:quantity/0","title":"Etherex.Type.quantity/0","type":"type"},{"doc":"Tags to represent the default block in some methods.","ref":"Etherex.Type.html#t:tag/0","title":"Etherex.Type.tag/0","type":"type"},{"doc":"Ether units","ref":"Etherex.Type.html#t:unit/0","title":"Etherex.Type.unit/0","type":"type"},{"doc":"EtherexEtherex is an Elixir high level library for the Ethereum blockchain. It is is based on the methods of the Json RPC API of Ethereum relying on library Ethreumex.","ref":"readme.html","title":"Etherex","type":"extras"},{"doc":"Ganache(https://github.com/trufflesuite/ganache): It is not an actual Ethereum node but &quot;an Ethereum simulator that makes developing Ethereum applications faster, easier, and safer&quot;.Status: all tests passVersion: Ganache CLI v6.12.2 (ganache-core: 2.13.2)Install: use npmGeth(https://geth.ethereum.org/): &quot;The official Go implementation of the Ethereum protocol&quot;Status: some tests pass, but important tests cannot be tested because we need to work in adding accounts by using config/genesis filesVersion: 1.10.15-stableInstall: use aptOpenethereum(https://openethereum.github.io/): &quot;Fast and feature-rich Ethereum client.&quot; implemented in RustStatus: some tests pass, but important tests cannot be tested because we need to work in adding accounts by using config/genesis filesVersion: v3.1.0-stableInstall: manual installation following instructions (just a binary)Ethnode(https://github.com/vrde/ethnode): It is not an actual Ethereum network is a zero configuration tool to run a local Ethereum node (Openethereum and Geth).Status with Openethereum: most tests pass, but there are two important errors:We cannot get a hash when a transaction &quot;fails&quot; (see test/etherex_errors_test.exs)There is an unexpected error: a transaction that should revert it is not failing (see test/etherex_compose_test.exs)Status with Geth: some tests pass, but important tests ariseVersion: 0.0.24Install: use npm","ref":"readme.html#ethereum-clients-or-nodes-or-evms","title":"Etherex - Ethereum Clients (or nodes or EVMs)","type":"extras"},{"doc":"ExW3 (https://github.com/hswick/exw3): ExW3 is a wrapper around ethereumex to provide a high level, user friendly json rpc api. This library is focused on providing a handy abstraction for working with smart contracts, and any other relevant utilities.Note. There is tool already named Etherex (https://github.com/etherex/etherex). The tool allows exchange in Ethereum by using a set of contracts.","ref":"readme.html#similar-applications","title":"Etherex - Similar Applications","type":"extras"},{"doc":"If a call returns a contract address, the address cannot be used as an instance() value: thinks about it.Improve error() type: a string is not enough. Our errors rely on responses like&lt; &quot;error&quot;: { &lt; &quot;message&quot;: &quot;VM Exception while processing transaction: revert not creator&quot;, &lt; &quot;code&quot;: -32000, &lt; &quot;data&quot;: { &lt; &quot;0xda850732121ff8b49f2922a40568ac8ecc2e2b6b46ce2f9a949184debfd33032&quot;: { &lt; &quot;error&quot;: &quot;revert&quot;, &lt; &quot;program_counter&quot;: 216, &lt; &quot;return&quot;: &quot;0x08c379a00000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000b6e6f742063726561746f72000000000000000000000000000000000000000000&quot;, &lt; &quot;reason&quot;: &quot;not creator&quot; &lt; }, &lt; &quot;stack&quot;: &quot;c: VM Exception while processing transaction: revert not creator\\n at Function.c.fromResults (/home/angel/node_modules/ganache-cli/build/ganache-core.node.cli.js:4:194812)\\n at w.processBlock (/home/angel/node_modules/ganache-cli/build/ganache-core.node.cli.js:42:53376)\\n at runMicrotasks (&lt;anonymous&gt;)\\n at processTicksAndRejections (internal/process/task_queues.js:97:5)&quot;, &lt; &quot;name&quot;: &quot;c&quot;Nevertheless, this message is specifically from Ganache (in non-compliant mode), so in a real blockchain that doesn’t work. The only way to return a result from a state-changing method is to use logs (called events in Solidity), but a revert (which is how require works) also rolls back all logs.The responses eth_sendTranscation in other Ethereum clients can be hash (try test/etherex_error_test.exs with Openethereum or Geth). Just to show the response to the same request in different clients:Ganache:13:35:12.843 [warn] %{&quot;code&quot; =&gt; -32000, &quot;data&quot; =&gt; %{&quot;0x4983a9bb2ef373ca1797b1d692befdda12e4e3f54804a4feff305eb2787daec7&quot; =&gt; %{&quot;error&quot; =&gt; &quot;revert&quot;, &quot;program_counter&quot; =&gt; 294, &quot;reason&quot; =&gt; &quot;message_of_revert&quot;, &quot;return&quot; =&gt; &quot;0x08c379a0000000000000000000000000000000000000000000000000000000000000002000000000000000000000000000000000000000000000000000000000000000116d6573736167655f6f665f726576657274000000000000000000000000000000&quot;}, &quot;name&quot; =&gt; &quot;c&quot;, &quot;stack&quot; =&gt; &quot;c: VM Exception while processing transaction: revert message_of_revert\\n at Function.c.fromResults (/home/angel/node_modules/ganache-cli/build/ganache-core.node.cli.js:4:194812)\\n at /home/angel/node_modules/ganache-cli/build/ganache-core.node.cli.js:42:52863&quot;}, &quot;message&quot; =&gt; &quot;VM Exception while processing transaction: revert message_of_revert&quot;}Openethereum:12:59:50.382 [warn] %{&quot;code&quot; =&gt; -32015, &quot;data&quot; =&gt; &quot;Reverted 0x08c379a0000000000000000000000000000000000000000000000000000000000000002000000000000000000000000000000000000000000000000000000000000000116d6573736167655f6f665f726576657274000000000000000000000000000000&quot;, &quot;message&quot; =&gt; &quot;VM execution error.&quot;}Geth:13:39:19.953 [warn] %{&quot;code&quot; =&gt; 3, &quot;data&quot; =&gt; &quot;0x08c379a0000000000000000000000000000000000000000000000000000000000000002000000000000000000000000000000000000000000000000000000000000000116d6573736167655f6f665f726576657274000000000000000000000000000000&quot;, &quot;message&quot; =&gt; &quot;execution reverted: message_of_revert&quot;}In Openethereum and Geth, the first 4 bytes (08c379a0) are the function selector - they can be discarded in order to get the actual error:iex(2)&gt; data = &quot;000000000000000000000000000000000000000000000000000000000000002000000000000000000000000000000000000000000000000000000000000000116d6573736167655f6f665f726576657274000000000000000000000000000000&quot; iex(3)&gt; data |&gt; Base.decode16!(case: :lower) |&gt; ABI.TypeDecoder.decode_raw([:string]) [&quot;message_of_revert&quot;]All functions must allow an opts argument to introduce optional parameters (eg. gas, gasPrice, nonce, tag).Compilation of Solidity via RPC is deprecated, avoid making the call, just use the local Solidity compiler.Create a DSL to run Etherex as a &quot;command line tool&quot;. This will require Etherex to be an application instead of a library. Ideas to explore: https://samuelmullen.com/articles/customizing_elixirs_iex. In any case, ask Ángel about &quot;bottle&quot;, he knows.Design a proper configuration for Etherex to be used in client applications. Likely, the library must be transformed in an application that load configuration on start up. Configuration will rely on Ethereumex configuration. Maybe the only configuration key is URL.Functions related to logs (eth_getFilterChanges, eth_getFilterLogs, eth_getLogs) and log extractionProper types and their encoding/decoding for transactions, receipts, logs, events, etc. Maybe, all of them can be defined in Etherex.Types.Pay attention to the deprecated functions in the JSON RPC API. For example, Openethereum logs say &quot;eth_accounts is deprecated and will be removed in future versions: Account management is being phased out see&quot;, or &quot;eth_sendTransaction is deprecated and will be removed in future versions: Account management is being phased out see&quot;. See APIs.Add functions that implements the &quot;Management APIs&quot; (eg. create account, lock/unlock account, etc.)More functions to control the time Etherex.Time (eg. snapshot, revert, increase time)Asynchronous (callbacks) for waiting a transaction to be mined or rejected by the blockchain. Review some common libraries like web3.js (https://web3js.readthedocs.io). For more examples visit https://ethereum.org/en/developers/docs/programming-languagesUse metaprogramming to generate an Elixir module with an interface to operations and events. Something like:defmodule SolidityExamples.Counter do use Etherex.SolidityContract, source: &quot;priv/solidity/Counter.sol&quot; endStart Geth with some accounts (do we need a &quot;genesis file&quot; for every client?).Add a new client module for Hyperledger Besu (https://besu.hyperledger.org). Different clients has different characteristics, for instance, besu seems to not expose the list of accounts.The following post is interesting, ilustrative, and crazy!: https://medium.com/coinmonks/common-attacks-in-solidity-and-how-to-defend-against-them-9bc3994c7c18","ref":"readme.html#todo","title":"Etherex - TODO","type":"extras"},{"doc":"According to Openethereum wiki (https://openethereum.github.io/), these are the APIs although not all of them are enabled:debugdebug_getBadBlockseth (enabled by default in Openethereum)eth_accounts (Etherex.accounts)eth_blockNumber (Etherex.blockNumber)eth_call (Etherex.call)eth_chainIdeth_coinbaseeth_estimateGas (Etherex.estimate_gas and Etherex.estimate_gas_cost)eth_gasPrice (Etherex.gas_price)eth_getBalance (Etherex.get_balance)eth_getBlockByHash (Etherex.get_block)eth_getBlockByNumber (Etherex.get_block)eth_getBlockTransactionCountByHash (Etherex.get_block)eth_getBlockTransactionCountByNumber (Etherex.get_block)eth_getCodeeth_getFilterChangeseth_getFilterLogseth_getLogs (Etherex.get_events)eth_getStorageAteth_getTransactionByBlockHashAndIndex (Etherex.get_transaction)eth_getTransactionByBlockNumberAndIndex (Etherex.get_transaction)eth_getTransactionByHash (Etherex.get_transaction)eth_getTransactionCounteth_getTransactionReceipt (Etherex.get_transaction_receipt)eth_getUncleByBlockHashAndIndexeth_getUncleByBlockNumberAndIndexeth_getUncleCountByBlockHasheth_getUncleCountByBlockNumbereth_getWorketh_hashrateeth_miningeth_newBlockFiltereth_newFiltereth_newPendingTransactionFiltereth_protocolVersion (Etherex.protocol_version)eth_sendRawTransactioneth_sendTransaction (Etherex.transfer, Etherex.deploy, Etherex.call_transaction)eth_signeth_signTransactioneth_submitHashrateeth_submitWorketh_syncingeth_uninstallFiltereth_pubsub (enabled by default in Openethereum)eth_subscribeeth_unsubscribenet (enabled by default in Openethereum)net_listening (Etherex.net_listening)net_peerCountnet_version (Etherex.net_version)parity (enabled by default in Openethereum)parity_allTransactionHashesparity_allTransactionsparity_callparity_cidV0parity_composeTransactionparity_consensusCapabilityparity_decryptMessageparity_encryptMessageparity_futureTransactionsparity_getBlockHeaderByNumberparity_getBlockReceiptsparity_hardwarePinMatrixAckparity_listOpenedVaultsparity_listStorageKeysparity_listVaultsparity_localTransactionsparity_lockedHardwareAccountsInfoparity_releasesInfoparity_signMessageparity_submitWorkDetailparity_verifySignatureparity_versionInfoparity_accountsparity_allAccountsInfoparity_changePasswordparity_deriveAddressHashparity_deriveAddressIndexparity_exportAccountparity_importGethAccountsparity_killAccountparity_listGethAccountsparity_newAccountFromPhraseparity_newAccountFromSecretparity_newAccountFromWalletparity_removeAddressparity_setAccountMetaparity_setAccountNameparity_testPasswordparity_pubsub (enabled by default in Openethereum)parity_subscribeparity_unsubscribeparity_setparity_acceptNonReservedPeersparity_addReservedPeerparity_dropNonReservedPeersparity_executeUpgradeparity_hashContentparity_removeReservedPeerparity_setAuthorparity_setChainparity_setEngineSignerparity_setExtraDataparity_setGasCeilTargetparity_setGasFloorTargetparity_setMaxTransactionGasparity_setMinGasPriceparity_setModeparity_setTransactionsLimitparity_upgradeReadypersonalpersonal_ecRecoverpersonal_listAccountspersonal_newAccountpersonal_sendTransactionpersonal_signpersonal_sign191personal_signTransactionpersonal_signTypedDatapersonal_unlockAccountprivateprivate_callprivate_composeDeploymentTransactionprivate_contractKeyprivate_sendTransactionsecretstore (enabled by default in Openethereum)signersigner_confirmRequestsigner_confirmRequestRawsigner_confirmRequestWithTokensigner_generateAuthorizationTokensigner_generateWebProxyAccessTokensigner_rejectRequestsigner_requestsToConfirmsigner_subscribePendingsigner_unsubscribePendingtrace (enabled by default in Openethereum)Ad-hoc Tracingtrace_calltrace_callManytrace_rawTransactiontrace_replayBlockTransactionstrace_replayTransactionTransaction-Trace Filteringtrace_blocktrace_filtertrace_gettrace_transactionweb3 (enabled by default in Openethereum)web3_clientVersionweb3_sha3Non standard APIevm (in Ganache-cli)evm_snapshotevm_revertevm_increaseTimeevm_mine (Etherex.Time.mine)","ref":"readme.html#supported-api","title":"Etherex - Supported API","type":"extras"},{"doc":"Erlang 21 or 22Elixir 1.7Ganache 6 (depends on Node 12, npm 6)solc (solidity compiler) 0.7.5Experimental: ethnode 0.0.24","ref":"readme.html#requirements","title":"Etherex - Requirements","type":"extras"},{"doc":"Install erlang using kerl (likely you will need to install a C compiler and some libraries to be installed in order to build releases): https://github.com/kerl/kerlInstall elixir using kiex: https://github.com/taylor/kiexInstall nodejs v12.x: https://nodejs.org/es/download/package-manager/Install solc: https://docs.soliditylang.org/en/v0.7.5/installing-solidity.html. Easy in Ubuntu:sudo add-apt-repository ppa:ethereum/ethereum sudo apt-get update sudo apt-get install solcInstall Ganache and Ethnode and add them to your pathcd $HOME npm install ganache ethnode PATH=$HOME/node_modules/.bin:$PATHStart Ethereum in a terminalYou can use ethnodeethnote openethereumor ganacheganache-cliCompile and start Elixir in other terminalmix deps.get mix compile iex -S mix","ref":"readme.html#use-and-tests","title":"Etherex - Use and tests","type":"extras"},{"doc":"Add etherex to your list of dependencies in mix.exs:def deps do [ {:etherex, git: &quot;https://gitlab.com/babel-upm/blockchain/etherex.git&quot;, tag: &quot;0.3.0&quot;} ] endDocumentation can be generated with ExDoc:mix docs","ref":"readme.html#documentation","title":"Etherex - Documentation","type":"extras"},{"doc":"Etherex Changelog","ref":"changelog.html","title":"Etherex Changelog","type":"extras"},{"doc":"[+] Added: for new features[-] Removed: for now removed features[C] Changed: for changes in existing functionality[F] Fixed: for any bug fixes[O] Obsolete: for soon-to-be removed features[T] Technical: change that doesn't affect the API (eg. refactoring, tooling, etc.)","ref":"changelog.html#legend","title":"Etherex Changelog - Legend","type":"extras"},{"doc":"[T]","ref":"changelog.html#next-release","title":"Etherex Changelog - Next release","type":"extras"},{"doc":"[T] Refactor of tests in order to test different nodes (Geth, Openethereum, Ethnode, etc.).[F] Some fixed decoding errors (decode_json_rpc_error).[+] Extracting the hash from errors when a hash exists.[+] A bit of inverse engineering for discovering some formats in different networks (Openethereum or Geth).","ref":"changelog.html#1-0-0-rc18","title":"Etherex Changelog - 1.0.0-rc18","type":"extras"},{"doc":"[F] Fix: decoding Events from logs fails when events in the log are not events from the given contract.[C] Fix: decoding RPC errors stopped working after upgrading ex_abi.[T] Library ex_abi updated to 5.6[+] New operations added: minor_start, minor_stop and evm_snapshot (in Etherex.Time)","ref":"changelog.html#1-0-0-rc17","title":"Etherex Changelog - 1.0.0-rc17","type":"extras"},{"doc":"[T] More tests: contracts as components of contracts.[F] Error decoding improved.[+] Default block parameter improved and added to all functions where it is relevant.[+] Etherex.syncing function added.","ref":"changelog.html#1-0-0-rc16","title":"Etherex Changelog - 1.0.0-rc16","type":"extras"},{"doc":"[F] Error fixed extracting events of a contract.","ref":"changelog.html#1-0-0-rc15","title":"Etherex Changelog - 1.0.0-rc15","type":"extras"},{"doc":"[C] Removed flag allowUnlimitedContractSize in GanacheCLI.[F] gasLimit flag in Ganache limited to max safe integer (9007199254740991).[+] Case {:error, :timeout} added to decode_json_rpc_error.[T] Command line in lib/etherex/client.ex constructed at compile time.","ref":"changelog.html#1-0-0-rc14","title":"Etherex Changelog - 1.0.0-rc14","type":"extras"},{"doc":"[C] Flag --optimize added to Solidity compiler.","ref":"changelog.html#1-0-0-rc13","title":"Etherex Changelog - 1.0.0-rc13","type":"extras"},{"doc":"[+] New clients: Openethereum and Geth (not with ethnode).[T] Specific arguments for starting Ethereum clients.[T] Tests for Etherex.Time.mine","ref":"changelog.html#1-0-0-rc12","title":"Etherex Changelog - 1.0.0-rc12","type":"extras"},{"doc":"[C] EthNode removed as a client, Openethereum and Geth are now clients (although for the moment both are started with ethnode).[C] Some error messages in logs when starting a client are now warnings.","ref":"changelog.html#1-0-0-rc11","title":"Etherex Changelog - 1.0.0-rc11","type":"extras"},{"doc":"[F] Some functions to return {:ok, nil} when the request does not fail but information is not processed yet. Eg. functions to get receipts, gas consumption, etc.[T] New interesting tests to check that development clients mine the block after transactions.[F] If Contract.get_events and Contract.get_contract_address to return {:ok, nil} if transaction is pending.[F] Fixing some error decodings in order to honor the type error().","ref":"changelog.html#1-0-0-rc10","title":"Etherex Changelog - 1.0.0-rc10","type":"extras"},{"doc":"[F] Avoiding match error when a client is started and start fails.","ref":"changelog.html#1-0-0-rc9","title":"Etherex Changelog - 1.0.0-rc9","type":"extras"},{"doc":"[C] Function renamed: Etherex.get_creation_hash -&gt; Etherex.get_contract_creation_hash[C] Function renamed: Etherex.get_creation_address -&gt; Etherex.get_contract_address[C] Function renamed: Contract.get_creation_address -&gt; Contract.get_address","ref":"changelog.html#1-0-0-rc8","title":"Etherex Changelog - 1.0.0-rc8","type":"extras"},{"doc":"[+] Functions related to contracts to get bytecode, creator, the has of the creationg transaction and address of the contract.[C] The names of some types has changed: compiled_code() -&gt; bytecode()[T] Very strong refactor: Etherex.CompiledCode moved to Contract, bytecode and contract instance are now actually opaque (includes some accessor).[T] Added a new module Etherex.Type with the basic types: address, hash, hex, tag, quantity, and unit.","ref":"changelog.html#1-0-0-rc7","title":"Etherex Changelog - 1.0.0-rc7","type":"extras"},{"doc":"[T] Tests added for gas cost and gas cost estimation.[+] Convenient function added: Etherex.estimate_gas_cost.","ref":"changelog.html#1-0-0-rc6","title":"Etherex Changelog - 1.0.0-rc6","type":"extras"},{"doc":"[+] Convenient function added: Etherex.gas_cost[+] Added methods Etherex.estimate_gas[T] README improved, mainly TODO entries added.","ref":"changelog.html#1-0-0-rc5","title":"Etherex Changelog - 1.0.0-rc5","type":"extras"},{"doc":"[+] New public module Etherex.Time with functions to simulate time events, for the moment &quot;mine&quot; to force a block to be mined.[T] Refactoring: moving some private functions from Etherex to Etherex.Helpers (to be used by other modules).[+] :latests as default parameter of Etherex.get_block/1.","ref":"changelog.html#1-0-0-rc4","title":"Etherex Changelog - 1.0.0-rc4","type":"extras"},{"doc":"[C] Minor change in solidity version to compile examples.[+] Ethereum clients as gen servers: API changed.[F] Added a case of error when the RPC error cannot be JSON decoded.","ref":"changelog.html#1-0-0-rc3","title":"Etherex Changelog - 1.0.0-rc3","type":"extras"},{"doc":"[+] Modules to start/stop Ethereum clients: Etherex.Client.{EthNode, GanacheCLI}","ref":"changelog.html#1-0-0-rc2","title":"Etherex Changelog - 1.0.0-rc2","type":"extras"},{"doc":"[+] Initial release with the following types and functions in module Etherex:Types: address/0 compiled_code/0 contract/0 error/0 event/0 hash/0 quantity/0 tag/0 unit/0Functions accounts/0 accounts!/0 block_number/0 block_number!/0 call/5 call!/5 call_transaction/5 call_transaction!/5 client_version/0 client_version!/0 compile_solidity/1 compile_solidity!/1 deploy/4 deploy!/4 gas_price/0 gas_price!/0 get_balance/1 get_balance!/1 get_block/1 get_block!/1 get_events/2 get_events!/2 get_transaction/1 get_transaction!/1 get_transaction_receipt/1 get_transaction_receipt!/1 net_listening/0 net_listening!/0 net_version/0 net_version!/0 protocol_version/0 protocol_version!/0 transfer/4 wei_to_decimal/2 wei_to_string/2","ref":"changelog.html#1-0-0-rc1","title":"Etherex Changelog - 1.0.0-rc1","type":"extras"}]